import { getMultiBioEntity } from '@/redux/bioEntity/bioEntity.thunks';
import { openBioEntityDrawerById, selectTab } from '@/redux/drawer/drawer.slice';
import { AppDispatch } from '@/redux/store';
import { searchFitBounds } from '@/services/pluginsManager/map/triggerSearch/searchFitBounds';
import { ElementSearchResult } from '@/types/models';
import { PluginsEventBus } from '@/services/pluginsManager/pluginsEventBus';

/* prettier-ignore */
export const handleAliasResults =
  (dispatch: AppDispatch, closestSearchResult: ElementSearchResult, hasFitBounds?: boolean, fitBoundsZoom?: number) =>
    async ({ id }: ElementSearchResult): Promise<void> => {

      dispatch(selectTab(`${id}`));
      dispatch(openBioEntityDrawerById(id));
      dispatch(
        getMultiBioEntity({
          searchQueries: [id.toString()],
          isPerfectMatch: true
        }),
      )
        .unwrap().then((bioEntityContents) => {

          PluginsEventBus.dispatchEvent('onSearch', {
            type: 'bioEntity',
            searchValues: [closestSearchResult],
            results: [bioEntityContents],
          });

          if (hasFitBounds) {
            searchFitBounds(fitBoundsZoom);
          }
        });
    };
