import { FIRST_ARRAY_ELEMENT } from '@/constants/common';
import { AppDispatch } from '@/redux/store';
import { ElementSearchResult } from '@/types/models';
import { PluginsEventBus } from '@/services/pluginsManager/pluginsEventBus';
import { handleAliasResults } from './handleAliasResults';
import { handleReactionResults } from './handleReactionResults';

interface HandleSearchResultActionInput {
  searchResults: ElementSearchResult[];
  dispatch: AppDispatch;
  hasFitBounds?: boolean;
  fitBoundsZoom?: number;
}

export const handleSearchResultAction = async ({
  searchResults,
  dispatch,
  hasFitBounds,
  fitBoundsZoom,
}: HandleSearchResultActionInput): Promise<void> => {
  const closestSearchResult = searchResults[FIRST_ARRAY_ELEMENT];
  const { type } = closestSearchResult;
  const action = {
    ALIAS: handleAliasResults,
    REACTION: handleReactionResults,
  }[type];

  await action(dispatch, closestSearchResult, hasFitBounds, fitBoundsZoom)(closestSearchResult);

  if (type === 'ALIAS') {
    PluginsEventBus.dispatchEvent('onBioEntityClick', closestSearchResult);
  }
};
